<!DOCTYPE html>
<html lang="en">

<head>
  <title>Task 29.20</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- font -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Lato">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
</head>

<body onload="onPageLoading()">
  <div class="container">
    <h2 class="text-center">Danh sách người dùng đăng ký</h2>
    <table id="user-table" class="table table-bordered table-striped table-hover">
      <thead>
        <tr>
          <th>Mã người dùng</th>
          <th>Firstname</th>
          <th>Lastname</th>
          <th>Age</th>
          <th>Action</th>
        </tr>
      </thead>
      <tbody>

      </tbody>
    </table>
  </div>

  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gJSON_USER = `{
    "description": "Data user",
    "users": [
      {
        "userId": 1,
        "firstname": "Test1",
        "lastname": "User1",
        "age": 18
      },
      {
        "userId": 2,
        "firstname": "Test2",
        "lastname": "User2",
        "age": 19
      },
      {
        "userId": 3,
        "firstname": "Test3",
        "lastname": "User3",
        "age": 18
      },
      {
        "userId": 4,
        "firstname": "Test4",
        "lastname": "User4",
        "age": 20
      },
      {
        "userId": 5,
        "firstname": "Test5",
        "lastname": "User5",
        "age": 21
      },
      {
        "userId": 6,
        "firstname": "Test6",
        "lastname": "User6",
        "age": 20
      }
    ]
  }`;
    // parsing json to object
    var gUserListObject = JSON.parse(gJSON_USER);

    const gEND_ROW_TABLE = -1;
    // hằng số số thứ tự các cột
    const gCOLUMN_USER_ID = 0;
    const gCOLUMN_FIRSTNAME = 1;
    const gCOLUMN_LASTNAME = 2;
    const gCOLUMN_AGE = 3;
    const gCOLUMN_ACTION = 4;

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    //Hàm xử lý khi nút chi tiết được ấn
    function onButtonChiTietClicked(paramButton) {
      console.log("Nút chi tiết được ấn");

      console.log("User Id: ", paramButton.dataset.id);
      console.log("User Firstname: ", paramButton.dataset.firstname);
      console.log("User Lastname: ", paramButton.dataset.lastname);
      console.log("User Age: ", paramButton.dataset.age);
    }

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // hàm xử lý sự kiện loading
    function onPageLoading() {
      // hiển thị dữ liệu lên table
      showDataOnTable(gUserListObject.users);
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // hiển thị dữ liệu lên table
    function showDataOnTable(paramUserList) {
      var vTable = document.getElementById("user-table");
      var vTableBody = vTable.getElementsByTagName("tbody")[0];

      for (var bIndex = 0; bIndex < paramUserList.length; bIndex++) {
        var vUser = paramUserList[bIndex];
        // tạo dòng mưới cho bẳng và ghi vào các giá trị 
        var row = vTableBody.insertRow(gEND_ROW_TABLE);

        var vCellUserId = row.insertCell(gCOLUMN_USER_ID);
        var vCellFirstname = row.insertCell(gCOLUMN_FIRSTNAME);
        var vCellLastname = row.insertCell(gCOLUMN_LASTNAME);
        var vCellAge = row.insertCell(gCOLUMN_AGE);
        var vCellAction = row.insertCell(gCOLUMN_ACTION);

        vCellUserId.innerHTML = vUser.userId;
        vCellFirstname.innerHTML = vUser.firstname;
        vCellLastname.innerHTML = vUser.lastname;
        vCellAge.innerHTML = vUser.age;
        vCellAction.innerHTML = "<button class='btn btn-info' onclick='onButtonChiTietClicked(this)' data-id='"
                + vUser.userId +"' data-firstname='"+ vUser.firstname +"' data-lastname='" + vUser.lastname 
                + "' data-age='" + vUser.age + "' >Chi tiết</button>";
      }
    }

  </script>

</body>

</html>
